
package com.topcoder.message.im;
import java.util.*;
/**
 * <p>MessageProcessor acts as a callback that handles incoming message. It is set to connection when it is open. MessageProcessor is required to be thread-safe because a connection could receive message from multiple sources concurrently. The first release comes with a simple MessageQueue that caches incoming message in a FIFO container. User can fetch messages from it.</p>
 * 
 */
public interface MessageProcessor {
/**
 * <p>Process an incoming message. This method could be invoked concurrently. Generally it should not throw exceptions (connection should not give null message to it).</p>
 * 
 * 
 * 
 * 
 * @param message the message to process
 * @exception NullPointerException if message is null
 */
    public void processMessage(com.topcoder.message.im.Message message);
}









