
package com.topcoder.message.im.connection;

/**
 * <p>MessageListener is a thread that listens for incoming socket requests. Several connection can share a same MessageListener. The purpose of separate sending and receiving socket is to avoid a complex protocol. MessageListener will simply accept any incoming request on the listening port and spawn a MessageReceiver thread to intercept any incoming message.</p>
 * 
 */
class MessageListener extends Thread {

/**
 * <p>The server socket to listen on. It is set in constructor and never changed during the life time of the MessageListener.</p>
 * 
 */
    private java.net.ServerSocket serverSocket = null;

/**
 * <p>The message processor to handle all incoming messagse. It is set in constructor and is never changed.</p>
 * 
 */
    private com.topcoder.message.im.MessageProcessor processor = null;

/**
 * <p>A set of active receivers created by this message listener. When listener is closing down the receivers will be disposed. Access to this set should be synchronized.</p>
 * 
 */
    private java.util.Set receivers = new HashSet();

/**
 * <p>Reference count of the listener. Not until it is not referenced by any connection will it be disposed. Initialized to 0 and increments with increaseReferenceCount() and decrements with close().</p>
 * 
 */
    private int referenceCount = 0;
/**
 * <p></p>
 */
    private com.topcoder.message.im.connection.AbstractSocketConnection listener;
/**
 * <p></p>
 * 
 * @poseidon-type com.topcoder.message.im.connection.MessageReceiver
 */
    public java.util.Collection messageReceiver = new java.util.TreeSet();

/**
 * <p>Create instance with server socket and message processor. It sets them to the field and starts itself as a thread.</p>
 * 
 * 
 * 
 * 
 * @param serverSocket the server socket to listen on
 * @param processor the message processor to handle messages
 * @exception NullPointerException if serverSocket or processor is null
 */
     MessageListener(java.net.ServerSocket serverSocket, com.topcoder.message.im.MessageProcessor processor) {        
        // your code here
    } 

/**
 * <p>Thread body. It uses a forever loop to accept incoming request and create MessageReceiver to handle it. The created receiver should be added to the receivers set so that they can be disposed later. If server socket throws IOException it should end the thread.</p>
 * 
 * 
 * 
 */
    public void run() {        
        // your code here
    } 

/**
 * <p>Decrease reference count by 1. If it drops to 0 dispose the listener. It will first close the serverSocket. Then it makes a copy of the receivers set and iterates through to dispose each receiver. Exceptions should not be propagated.</p>
 * 
 * 
 * 
 */
    public void close() {        
        // your code here
    } 

/**
 * <p>Get the message processor. Simply return the processor field.</p>
 * 
 * 
 * 
 * 
 * @return the message processor
 */
    public com.topcoder.message.im.MessageProcessor getMessageProcessor() {        
        // your code here
        return null;
    } 

/**
 * <p>Get the port the socket is listening on. Return serverSocket.getLocalPort().</p>
 * 
 * 
 * 
 * 
 * @return the listening port
 */
    public int getListeningPort() {        
        // your code here
        return 0;
    } 

/**
 * <p>Increase reference count by 1.</p>
 * 
 * 
 * 
 */
    public void increaseReferenceCount() {        
        // your code here
    } 
/**
 * <p></p>
 */
    public java.net.ServerSocket serverSocket;
 }
