
package com.topcoder.message.im.profile;

/**
 * <p>UserProfile represents the identity of a user for the instant messaging. It subclasses MessaginObject. For now it has five fields, username, password, screen name, email address and visibility. Username is the unique identifier of the profile and is immutable. The rest of the fields can be mutated.</p>
 * 
 */
public class UserProfile extends com.topcoder.message.im.MessagingObject {

/**
 * <p>Username of the profile. It is the unique identifier of the profile and is immutable.</p>
 * 
 */
    private String username = null;

/**
 * <p>Password of the user. It is mutable with setter and getter.</p>
 * 
 */
    private String password = null;

/**
 * <p>Screen name of the user. It is mutable with setter and getter.</p>
 * 
 */
    private String screenName = null;

/**
 * <p>Email address of the user. It is mutable with setter and getter.</p>
 * 
 */
    private String emailAddress = null;

/**
 * <p>Visibility of this profile. It is mutable with setter and getter.</p>
 * 
 */
    private com.topcoder.message.im.profile.ProfileVisibility visibility = null;
/**
 * <p></p>
 */
    public com.topcoder.message.im.profile.ProfileVisibility profileVisibility;

/**
 * <p>Creates instance with given username. Stores it to the field.</p>
 * 
 * 
 * 
 * 
 * @param username username of the profile
 * @exception NullPointerException if username is null
 * @exception IllegalArgumentException if username is empty
 */
    public  UserProfile(String username) {        
        // your code here
    } 

/**
 * <p>Create instance with complete information. Stores them to respective fields.</p>
 * 
 * 
 * 
 * 
 * @param username username of the profile
 * @param password user's password
 * @param screenName user's screen name
 * @param emailAddress user's email address
 * @param visibility visibility of the profile
 * @exception NullPointerException if username or password or screenName or emailAddress or visibility is null
 * @exception IllegalArgumentException if username is empty
 */
    public  UserProfile(String username, String password, String screenName, String emailAddress, com.topcoder.message.im.profile.ProfileVisibility visibility) {        
        // your code here
    } 

/**
 * <p>Get user name of the profile.</p>
 * 
 * 
 * 
 * 
 * @return user name of the profile
 */
    public String getUsername() {        
        // your code here
        return null;
    } 

/**
 * <p>Set password of the user.</p>
 * 
 * 
 * 
 * 
 * @param password password of the user
 * @exception NullPointerException if password is null
 */
    public void setPassword(String password) {        
        // your code here
    } 

/**
 * <p>Get password of the user.</p>
 * 
 * 
 * 
 * 
 * @return password of the user
 */
    public String getPassword() {        
        // your code here
        return null;
    } 

/**
 * <p>Set screen name of the user.</p>
 * 
 * 
 * 
 * 
 * @param screenName screen name of the user
 * @exception NullPointerException if screenName is null
 */
    public void setScreenName(String screenName) {        
        // your code here
    } 

/**
 * <p>Get screen name of the user.</p>
 * 
 * 
 * 
 * 
 * @return screen name of the user
 */
    public String getScreenName() {        
        // your code here
        return null;
    } 

/**
 * <p>Set email address of the user.</p>
 * 
 * 
 * 
 * 
 * @param emailAddress email address of the user
 * @exception NullPointerException if emailAddress is null
 */
    public void setEmailAddress(String emailAddress) {        
        // your code here
    } 

/**
 * <p>Get email address of the user.</p>
 * 
 * 
 * 
 * 
 * @return email address of the user
 */
    public String getEmailAddress() {        
        // your code here
        return null;
    } 

/**
 * <p>Set visibility of the profile.</p>
 * 
 * 
 * 
 * 
 * @param visibility visibility of the profile
 * @exception NullPointerException if visibility is null
 */
    public void setVisibility(com.topcoder.message.im.profile.ProfileVisibility visibility) {        
        // your code here
    } 

/**
 * <p>Get visibility of the profile.</p>
 * 
 * 
 * 
 * 
 * @return visibility of the profile
 */
    public com.topcoder.message.im.profile.ProfileVisibility getVisibility() {        
        // your code here
        return null;
    } 
 }
